# Create raw time tracking shifts

POST https://api.letsdeel.com/rest/v2/time_tracking/shifts/raw
Content-Type: application/json

Create raw shifts for the specified contract ID. “Raw shifts” refers to uncategorized entries—simply submit the clock-in and clock-out times. The classification of those hours (e.g., regular or overtime) will be handled by the Deel platform.
 **Token scopes**: `time-tracking:write`

Reference: https://developer.deel.com/api/endpoints/time-tracking-shifts/create-time-tracking-shifts-raw

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /time_tracking/shifts/raw:
    post:
      operationId: create-time-tracking-shifts-raw
      summary: Create raw time tracking shifts
      description: >-
        Create raw shifts for the specified contract ID. “Raw shifts” refers to
        uncategorized entries—simply submit the clock-in and clock-out times.
        The classification of those hours (e.g., regular or overtime) will be
        handled by the Deel platform.
         **Token scopes**: `time-tracking:write`
      tags:
        - subpackage_timeTrackingShifts
      parameters:
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Successful operation.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/time-tracking-shifts_createTimeTrackingShiftsRaw_Response_201
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
      requestBody:
        description: Request body to create time tracking raw shifts.
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaData
                  description: >-
                    Request data containing contract ID and shifts to be
                    created.
              required:
                - data
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaEnd:
      type: object
      properties:
        date:
          type: string
          description: End date
        time:
          type: string
          description: End time
        is_rest_day:
          type: boolean
          description: Is rest day
        is_public_holiday:
          type: boolean
          description: Is public holiday
      description: End time details of the shift.
      title: >-
        TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaEnd
    TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaStart:
      type: object
      properties:
        date:
          type: string
          description: Start date
        time:
          type: string
          description: Start time
        is_rest_day:
          type: boolean
          description: Is rest day
        is_public_holiday:
          type: boolean
          description: Is public holiday
      description: Start time details of the shift.
      title: >-
        TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaStart
    TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaBreaksItemsEnd:
      type: object
      properties:
        date:
          type: string
          description: Break end date
        time:
          type: string
          description: Break end time
      description: End time details of the break.
      title: >-
        TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaBreaksItemsEnd
    TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaBreaksItemsStart:
      type: object
      properties:
        date:
          type: string
          description: Break start date
        time:
          type: string
          description: Break start time
      description: Start time details of the break.
      title: >-
        TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaBreaksItemsStart
    TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaBreaksItems:
      type: object
      properties:
        end:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaBreaksItemsEnd
          description: End time details of the break.
        start:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaBreaksItemsStart
          description: Start time details of the break.
        is_paid:
          type: boolean
          description: Is break paid
      title: >-
        TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaBreaksItems
    TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMeta:
      type: object
      properties:
        end:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaEnd
          description: End time details of the shift.
        start:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaStart
          description: Start time details of the shift.
        breaks:
          type: array
          items:
            $ref: >-
              #/components/schemas/TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMetaBreaksItems
          description: List of break periods within the shift.
        approval_date:
          type: string
          description: Approval date
      description: >-
        Metadata containing detailed information about the shift timing, breaks,
        and approval status.
      title: >-
        TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMeta
    TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItems:
      type: object
      properties:
        meta:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsMeta
          description: >-
            Metadata containing detailed information about the shift timing,
            breaks, and approval status.
        description:
          type: string
          description: Description of the shift.
        external_id:
          type: string
          description: Extrenal ID of the shift.
        date_of_work:
          type: string
          description: Date of shift work
      required:
        - meta
        - external_id
        - date_of_work
      title: >-
        TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItems
    TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        shifts:
          type: array
          items:
            $ref: >-
              #/components/schemas/TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaDataShiftsItems
          description: Array of shift records to be created.
        contract_id:
          type: string
          description: Contract ID associated with the shifts.
      required:
        - shifts
        - contract_id
      description: Request data containing contract ID and shifts to be created.
      title: TimeTrackingShiftsRawPostRequestBodyContentApplicationJsonSchemaData
    TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaEnd:
      type: object
      properties:
        date:
          type: string
          description: End date
        time:
          type: string
          description: End time
        is_rest_day:
          type: boolean
          description: Is rest day
        is_public_holiday:
          type: boolean
          description: Is public holiday
      description: End time details of the shift.
      title: >-
        TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaEnd
    TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaStart:
      type: object
      properties:
        date:
          type: string
          description: Start date
        time:
          type: string
          description: Start time
        is_rest_day:
          type: boolean
          description: Is rest day
        is_public_holiday:
          type: boolean
          description: Is public holiday
      description: Start time details of the shift.
      title: >-
        TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaStart
    TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsEnd:
      type: object
      properties:
        date:
          type: string
          description: Break end date
        time:
          type: string
          description: Break end time
      description: End time details of the break.
      title: >-
        TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsEnd
    TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsStart:
      type: object
      properties:
        date:
          type: string
          description: Break start date
        time:
          type: string
          description: Break start time
      description: Start time details of the break.
      title: >-
        TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsStart
    TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItems:
      type: object
      properties:
        end:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsEnd
          description: End time details of the break.
        start:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsStart
          description: Start time details of the break.
        is_paid:
          type: boolean
          description: Is break paid
      title: >-
        TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItems
    TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMeta:
      type: object
      properties:
        end:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaEnd
          description: End time details of the shift.
        start:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaStart
          description: Start time details of the shift.
        breaks:
          type: array
          items:
            $ref: >-
              #/components/schemas/TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItems
          description: List of break periods within the shift.
        approval_date:
          type: string
          description: Approval date of the shift.
      description: >-
        Metadata containing detailed information about the shift timing, breaks,
        and approval status.
      title: >-
        TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMeta
    TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItems:
      type: object
      properties:
        meta:
          $ref: >-
            #/components/schemas/TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItemsMeta
          description: >-
            Metadata containing detailed information about the shift timing,
            breaks, and approval status.
        created_at:
          type: string
          description: Creation timestamp of the shift.
        updated_at:
          type: string
          description: Last update timestamp of the shift.
        contract_id:
          type: string
          description: Contract identifier.
        description:
          type: string
          description: Description of the shift.
        external_id:
          type: string
          description: Unique identifier of the shift.
        date_of_work:
          type: string
          description: Date of the shift.
      required:
        - meta
        - contract_id
        - external_id
        - date_of_work
      title: TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItems
    time-tracking-shifts_createTimeTrackingShiftsRaw_Response_201:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: >-
              #/components/schemas/TimeTrackingShiftsRawPostResponsesContentApplicationJsonSchemaDataItems
          description: List of created shift records.
      required:
        - data
      title: time-tracking-shifts_createTimeTrackingShiftsRaw_Response_201
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/time_tracking/shifts/raw"

payload = { "data": {
        "shifts": [
            {
                "meta": {},
                "external_id": "shift_123456",
                "date_of_work": "2023-10-01"
            }
        ],
        "contract_id": "397w2dy"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/time_tracking/shifts/raw';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"shifts":[{"meta":{},"external_id":"shift_123456","date_of_work":"2023-10-01"}],"contract_id":"397w2dy"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/time_tracking/shifts/raw"

	payload := strings.NewReader("{\n  \"data\": {\n    \"shifts\": [\n      {\n        \"meta\": {},\n        \"external_id\": \"shift_123456\",\n        \"date_of_work\": \"2023-10-01\"\n      }\n    ],\n    \"contract_id\": \"397w2dy\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/time_tracking/shifts/raw")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"shifts\": [\n      {\n        \"meta\": {},\n        \"external_id\": \"shift_123456\",\n        \"date_of_work\": \"2023-10-01\"\n      }\n    ],\n    \"contract_id\": \"397w2dy\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/time_tracking/shifts/raw")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"shifts\": [\n      {\n        \"meta\": {},\n        \"external_id\": \"shift_123456\",\n        \"date_of_work\": \"2023-10-01\"\n      }\n    ],\n    \"contract_id\": \"397w2dy\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/time_tracking/shifts/raw', [
  'body' => '{
  "data": {
    "shifts": [
      {
        "meta": {},
        "external_id": "shift_123456",
        "date_of_work": "2023-10-01"
      }
    ],
    "contract_id": "397w2dy"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/time_tracking/shifts/raw");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"shifts\": [\n      {\n        \"meta\": {},\n        \"external_id\": \"shift_123456\",\n        \"date_of_work\": \"2023-10-01\"\n      }\n    ],\n    \"contract_id\": \"397w2dy\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "shifts": [
      [
        "meta": [],
        "external_id": "shift_123456",
        "date_of_work": "2023-10-01"
      ]
    ],
    "contract_id": "397w2dy"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/time_tracking/shifts/raw")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```